const AccessControl = require('accesscontrol');

const grants = {
    admin: {
        mapmarker: {
            "create:any": [],
            "delete:any": [],
            "read:any": [],
            "update:any": []
        },
        powerup: {
            "create:any": [],
            "delete:any": [],
            "read:any": [],
            "update:any": []
        },
        faction: {
            "create:any": [],
            "delete:any": [],
            "read:any": [],
            "update:any": []
        },
        players: {
            "create:any": [],
            "delete:any": [],
            "read:any": [],
            "update:any": []
        }
    },
    faction_leader: {
        mapmarker: {
            "create:own": [],
            "delete:own": [],
            "read:own": []
        },
        powerup: {
            "read:own": []
        },
        faction: {
            "read:own": [],
            "update:own": []
        },
        players: {
            "read:own": [],
            "update:own": []
        }
    }
};

const ac = new AccessControl(grants);

/*const express = require ('express');
const router express.Router;
*/
/*const ac = new AccessControl();
ac.grant('faction_leader')                    // define new or modify existing role. also takes an array.
    .createOwn('mapmarker')             // equivalent to .createOwn('video', ['*'])
    .deleteOwn('mapmarker')
    .readOwn('mapmarker')
  .grant('admin')                   // switch to another role without breaking the chain
    .extend('user')                 // inherit role capabilities. also takes an array
    .updateAny('mapmarker', ['title'])  // explicitly defined attributes
    .deleteAny('mapmarker')
    .readAny('mapmarker');

/*const*//*let permission = ac.can('user').createOwn('mapmarker');
console.log(permission.granted);    // —> true
console.log(permission.attributes); // —> ['*'] (all attributes)

permission = ac.can('admin').updateAny('mapmarker');
console.log(permission.granted);    // —> true
console.log(permission.attributes); // —> ['title']

/*router.get('/videos/:title', function (req, res, next) {
    const permission = ac.can(req.user.role).readAny('video');
    if (permission.granted) {
        Video.find(req.params.title, function (err, data) {
            if (err || !data) return res.status(404).end();
            // filter data by permission attributes and send.
            res.json(permission.filter(data));
        });
    } else {
        // resource is forbidden for this user/role
        res.status(403).end();
    }
});*/